include \masm32\include\masm32rt.inc
.686p
.mmx
.xmm

MENUBARINFO struct
    cbSize      DWORD   ?
    rcBar       RECT    <>
    hMenu       HMENU   ?
    hwndMenu    HWND    ?
    flags       SDWORD  ? ; fBarFocused=1 , fFocused=2
    ;fBarFocused : 1
    ;fFocused   : 1
MENUBARINFO ends
PMENUBARINFO typedef ptr MENUBARINFO

.data?
    hInstance   HINSTANCE   ?
    hwnd        HWND        ?
    cxFrame     DWORD       ?
    cxMin       DWORD       ?
.code

WndProc proto hWnd:HWND,uMgs:UINT,wParam:WPARAM,lParam:LPARAM

main proc
LOCAL wc:WNDCLASSEX
LOCAL msg:MSG

    mov hInstance,rv(GetModuleHandle,0)
    mov wc.hInstance,eax
    mov wc.cbSize,SIZEOF wc
    mov wc.style,CS_HREDRAW or CS_VREDRAW or CS_SAVEBITS
    mov wc.lpfnWndProc,OFFSET WndProc
    mov wc.cbClsExtra,0
    mov wc.cbWndExtra,0
    mov wc.hIcon,rv(LoadIcon,0,IDI_APPLICATION)
    mov wc.hIconSm,eax
    mov wc.hCursor,rv(LoadCursor,0,IDC_ARROW)
    mov wc.lpszMenuName,0
    mov wc.hbrBackground,rv(GetStockObject,WHITE_BRUSH);
    mov wc.lpszClassName,chr$("Win32Wnd")
    invoke RegisterClassEx,ADDR wc
    
    mov esi,rv(CreateMenu)
    fn AppendMenu,esi,MF_STRING,1,"entry1"
    fn AppendMenu,esi,MF_STRING,2,"entry2"
    fn AppendMenu,esi,MF_STRING,3,"entry3"
    fn AppendMenu,esi,MF_STRING,4,"entry4"
    
    mov ebx,ASM(mov edi,rv(GetSystemMetrics,SM_CXSCREEN))
    mov ecx,rv(GetSystemMetrics,SM_CYSCREEN)
    shr ebx,1
    shr eax,1
    shr edi,2
    shr ecx,2
    mov esi,rv(CreateWindowEx,0,wc.lpszClassName,"Win32Wnd",WS_VISIBLE or WS_SYSMENU or WS_MAXIMIZEBOX or WS_MINIMIZEBOX or WS_SIZEBOX,edi,ecx,ebx,eax,0,esi,hInstance,0)
    mov hwnd,eax
    invoke UpdateWindow,esi 
    
    .while 1
        invoke GetMessage,ADDR msg,0,0,0
        .break .if !eax || eax == -1
        invoke TranslateMessage,ADDR msg
        invoke DispatchMessage,ADDR msg     
    .endw

    invoke ExitProcess,0
    
main endp

WndProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL rect[2]:RECT
LOCAL mbi:MENUBARINFO

    .if uMsg == WM_CLOSE
        invoke PostQuitMessage,0
    .elseif uMsg == WM_CREATE
        invoke GetClientRect,hWnd,ADDR rect
        invoke GetWindowRect,hWnd,ADDR rect[16]
        mov edx,rect[16].right
        sub edx,rect[16].left
        sub edx,rect.right
        mov cxFrame,edx
        mov mbi.cbSize,SIZEOF mbi
        invoke GetMenuBarInfo,hWnd,OBJID_MENU,4,ADDR mbi    ; coord. are relativ to screen!
        mov eax,mbi.rcBar.right
        sub eax,rect[16].left
        add eax,cxFrame
        add eax,2
        mov cxMin,eax   
    .elseif uMsg == WM_GETMINMAXINFO
        mov edx,lParam
        m2m [edx].MINMAXINFO.ptMinTrackSize.x,cxMin
    .else
        invoke DefWindowProc,hWnd,uMsg,wParam,lParam
        ret
    .endif
    
    xor eax,eax
    ret
    
WndProc endp
end main